<?php  // $Id: cck_basic.inc,v 1.2 2009/07/28 13:53:35 peterboeren Exp $

/**
 * @file
 * The filters that handlers to cope with the effects of an
 * different form element. Most needed for checkboxes because
 * radios and select uses the same syntax in $element (see form.inc)
 */

/**
 * Basic handler for altering the query
 *
 * @param array $placeholders
 * @param integer $clauses_key
 * @param object $view
 * @param object $query
 * @param object $display
 * @param string $table
 * @param string $field
 * @param string $fieldtype
 */
function vfph_cck_basic($placeholders, $clauses_key, &$view, &$query, $display, $table, $field, $fieldtype = NULL) {
  // Determine the exposed key for a field. This needed to determine the post
  // values.
  $exposed_key = _views_filter_pack_retrieve_exposed_key($view, $display, $table, $field);
  // Determine what values are posted.
  $formstate = _view_filter_pack_get_formstate($view, $display, $fieldtype, $table, $field, $exposed_key);
  // Build an array of placeholders.
  $build_placeholders = _views_filter_pack_build_placeholders($formstate);
  // prepare the arguments in the query object. Every placeholder should have an
  // argument.
  _views_filter_pack_alter_args($clauses_key, $query, $formstate);

  //$exposed_key = $field;

  // Rebuild the correct field name for CCK fields
  $fields_information = views_filter_pack_register_fields();
  // In most case the field will be a concatination of tabel and field.
  $field = $table .'.'. $field;
  // But there are exceptions, so let other modules determine the correct name
  $field = module_invoke_all('alter_field_information', $field, $display);
  $field = $field[0];

  // This is where we rewrite the query.
  switch ($fieldtype) {
    case 'checkboxes':
      if (is_array($formstate) && count($formstate)) {
        $query->where[0]['clauses'][$clauses_key] = $field ." in(". $build_placeholders .")";
      }
      else {
        // No filtering then no clause is needed
        unset($query->where[0]['clauses'][$clauses_key]);
      }
      break;
    case 'radios':
      if (!is_array($formstate) && ($formstate <> 'All') && drupal_strlen($formstate)) {
        $query->where[0]['clauses'][$clauses_key] = $field ." = '". $build_placeholders ."'";
      }
      else {
        // No filtering then no clause is needed
        unset($query->where[0]['clauses'][$clauses_key]);
      }
      break;
  }
  return;
}